org.codehaus.groovy.vmplugin

## Interface VMPlugin

All Known Implementing Classes:
  Java5, Java6, Java7, Java8

    public interface VMPlugin

Interface to access VM version based actions. This interface is for internal use only!

Author:
  Jochen Theodorou

### Method Summary

All Methods Instance Methods Abstract Methods
`void` `configureAnnotation(AnnotationNode an)`
`void` `configureClassNode(CompileUnit compileUnit, ClassNode classNode)`
`java.lang.Object` `getInvokeSpecialHandle(java.lang.reflect.Method m, java.lang.Object receiver)` Returns a handle with bound receiver to invokeSpecial the given method.
`java.lang.Class[]` `getPluginDefaultGroovyMethods()`
`java.lang.Class[]` `getPluginStaticGroovyMethods()`
`int` `getVersion()` Gives the version the plguin is made for
`void` `invalidateCallSites()`
`java.lang.Object` `invokeHandle(java.lang.Object handle, java.lang.Object[] args)` Invokes a handle produced by #getInvokeSpecialdHandle
`void` `setAdditionalClassInformation(ClassNode c)`

### Method Detail

#### setAdditionalClassInformation

    void setAdditionalClassInformation(ClassNode c)

#### getPluginDefaultGroovyMethods

    java.lang.Class[] getPluginDefaultGroovyMethods()

#### getPluginStaticGroovyMethods

    java.lang.Class[] getPluginStaticGroovyMethods()

#### configureAnnotation

    void configureAnnotation(AnnotationNode an)

#### configureClassNode

    void configureClassNode(CompileUnit compileUnit,
                            ClassNode classNode)

#### invalidateCallSites

    void invalidateCallSites()

#### getInvokeSpecialHandle

    java.lang.Object getInvokeSpecialHandle(java.lang.reflect.Method m,
                                            java.lang.Object receiver)

Returns a handle with bound receiver to invokeSpecial the given method. This method will require at least Java 7, but since the source has to compile on older Java versions as well it is not marked to return a MethodHandle and uses Object instead

Returns:
  null in case of jdk<7, otherwise a handle that takes the method call arguments for the invokespecial call

#### invokeHandle

    java.lang.Object invokeHandle(java.lang.Object handle,
                                  java.lang.Object[] args)
                           throws java.lang.Throwable

Invokes a handle produced by #getInvokeSpecialdHandle

Parameters:
  `handle` - the handle
  `args` - arguments for the method call, can be empty but not null
Returns:
  the result of the method call
Throws:
  `java.lang.Throwable`

#### getVersion

    int getVersion()

Gives the version the plguin is made for

Returns:
  5 for jdk5, 6 for jdk6, 7 for jdk7 or higher